#!/usr/bin/php
<?
//Small script to emit the particle gfx data from particles.png


function emit($v) {
	//Helper function to emit an array
	static $first=true;
	static $no=0;
	if ($first) {
		echo "const unsigned int particleGfx[]={";
		$first=false;
	} else {
		echo ", ";
	}

	if (($no&15)==0) {
		printf("\n\t");
	}
	printf("0x%08X", $v);
	$no++;
}

//Array:
//32 bits -> 32 pixels in x-direction
//32 of these for y-direction
//8 of these for size
//8 of these for particle image
//--> 8K of image data

$sizes=array(1, 1.1, 1.3, 1.5, 1.7, 2, 2.5, 3);
$parts=imagecreatefrompng("particles.png");
$work=imagecreatetruecolor(32, 32);
$black=imagecolorallocate($work, 0, 0, 0);

for ($img=0; $img<8; $img++) {
	for ($sz=0; $sz<8; $sz++) {
		//Copy the scaled particle to $work
		imagefilledrectangle($work, 0,0,32,32, $black);
		$margin=(32-(8*$sizes[$sz]))/2;
		imagecopyresized($work, $parts, $margin, $margin, 8*$img, 0, 8*$sizes[$sz], 8*$sizes[$sz], 8,8);
		
		//Emit words containing the values of one row of pixels
		for ($y=0; $y<32; $y++) {
			$v=0;
			for ($x=0; $x<32; $x++) {
				$v=$v<<1;
				$c=imagecolorat($work, $x, $y);
				$g = ($c >> 8) & 0xFF;
				if ($g>128) $v|=1;
			}
			emit($v);
		}
	}
}

echo "\n\t};";

?>