#include <stdio.h>
#include <math.h>
#include <stdlib.h>

void getPortalTexture(unsigned int* imageData) {
	//This is the portal texture generating code I 'borrowed' from the Minecraft sourcecode. No
	//idea what it does exactly, I just know it outputs a nice swirl.
	int i,j,k,l;
	unsigned int r,g,b,a;
	int p=0;
	for (i=0; i<32; i++) {
	for (j=0; j<16; j++) {
		for (k=0; k<16; k++) {
			float f=0;
			for (l=0; l<2; l++) {
				float f1=l*8;
				float f2=l*8;
				float f3=(((float)j-f1)/16.0)*2.0;
				float f4=(((float)k-f2)/16.0)*2.0;
				if (f3<-1) f3+=2;
				if (f3>=1) f3-=2;
				if (f4<-1) f4+=2;
				if (f4>=1) f4-=2;
				float f5=f3*f3+f4*f4;
				float f6=atan2(f4, f3)+(((((float)i/32.0)*3.141593F*2.0-f5*10.0)+(float)(l*2))*(float)(l*2-1));
				f6=sin((f6)+1.0)/2.0;
				f6/=f5+1.0;
				f+=f6*0.5;
			}
			f+=((float)(rand()/10)/RAND_MAX);
			r=(f*f*200+55);	//r
			g=(f*f*f*f*255);	//g
			b=(f*100+155);		//b
			a=(f*100+155);		//alpha
			
			//Somehow, the end result in Minecraft is much more purple-ish. Compensate for that.
			r*=1.5; 

			if (r>255) r=255;
			if (g>255) r=255;
			if (b>255) r=255;
			if (a>255) r=255;
			imageData[p++]=(a<<24)+(r<<16)+(g<<8)+b;
		}
	}
	}
}

int main() {
	int x;
	unsigned int gfx[16*16*32];
	//Generate the textures
	getPortalTexture(gfx);

	//..and output them as a big array.
	printf("const unsigned int portalTileGfx[]={");
	for (x=0; x<16*16*32; x++) {
		if ((x&15)==0) {
			printf("\n\t0x%08x", gfx[x]);
		} else {
			printf("0x%08x", gfx[x]);
		}
		if (x!=16*16*32-1) printf(", ");
	}
	printf("\n\t};\n");
	exit(0);
}
